package nl.amis.view;

import javax.el.ELContext;
import javax.el.ExpressionFactory;

import javax.el.MethodExpression;

import javax.faces.context.FacesContext;

import javax.faces.event.PhaseId;

import oracle.adf.controller.TaskFlowId;
import oracle.adf.view.rich.component.rich.RichPopup;
import oracle.adf.view.rich.component.rich.fragment.RichRegion;
import oracle.adf.view.rich.event.PopupCanceledEvent;
import oracle.adf.view.rich.event.PopupFetchEvent;
import oracle.adf.view.rich.event.RegionNavigationEvent;

public class PopupTaskflowHandler {
    private String taskFlowId =
        "/WEB-INF/task-flow-definition.xml#task-flow-definition";
    private String emptyTaskFlowId = "";
    private String currentTaskflowId = taskFlowId;

    public String getDynamicTaskFlowId() {
        return currentTaskflowId;
    }

    public void cancelPopup(PopupCanceledEvent pce) {
        currentTaskflowId = emptyTaskFlowId;
        FacesContext fc = FacesContext.getCurrentInstance();
        ExpressionFactory ef = null;
        ef = fc.getApplication().getExpressionFactory();
        ELContext ec = fc.getELContext();
        MethodExpression me = null;
        me = ef.createMethodExpression( ec, "#{centralBean.getExit}"
                                      , String.class, new Class[] { });
        region.queueActionEventInRegion(me, null, null, false, 0, 0
                                        , PhaseId.INVOKE_APPLICATION);
    }

    private RichRegion region;

    public void setRegion(RichRegion region) {
        this.region = region;
    }

    public RichRegion getRegion() {
        return region;
    }

    public void showPopup(PopupFetchEvent popupFetchEvent) {
        currentTaskflowId = taskFlowId;
    }

    private RichPopup popup;

    public void hearNavigation(RegionNavigationEvent regionNavigationEvent) {
        String newViewId = regionNavigationEvent.getNewViewId();
        if (newViewId ==
            null) { // navigation outside any viewActivity - surely that means exit!
            // reset the taskflow
            currentTaskflowId = emptyTaskFlowId;
            // close the popup
            popup.hide();
        }
    }

    public void setPopup(RichPopup popup) {
        this.popup = popup;
    }

    public RichPopup getPopup() {
        return popup;
    }

}
